//+------------------------------------------------------------------+
//|                                                 Heiken Ashi.mq4  |
//|-------------------------------------------------------------------
#property link      "www.forex-tsd.com"      
#property copyright "www.forex-tsd.com" 

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  Red
#property indicator_color2  White
#property indicator_color3  Red
#property indicator_color4  White

//
//
//
//
//

extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double Buffer4[]; 
double trend[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//               

int init()
{
    IndicatorBuffers(5);
    SetIndexBuffer(0, Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
    SetIndexBuffer(1, Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
    SetIndexBuffer(2, Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
    SetIndexBuffer(3, Buffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
    SetIndexBuffer(4, trend);
    IndicatorShortName("Heiken Ashi");   
return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int pos,limit;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);   
          
   //
   //
   //
   //
   //
   
   for (pos=limit; pos >= 0; pos--)
   {                      
       double haClose = (Open[pos]+High[pos]+Low[pos]+Close[pos])/4;
       double haOpen  = (Buffer3[pos+1]+Buffer4[pos+1])/2;
       double haHigh  = MathMax(High[pos],MathMax(haOpen,haClose));
       double haLow   = MathMin(Low[pos], MathMin(haOpen,haClose));
          
       if (haOpen<haClose) { Buffer1[pos]=haLow;  Buffer2[pos]=haHigh; } 
       else                { Buffer1[pos]=haHigh; Buffer2[pos]=haLow;  } 
                             Buffer3[pos]=haOpen;
                             Buffer4[pos]=haClose;  
      
       trend[pos] = trend[pos+1];
           if (Buffer3[pos] < Buffer4[pos]) trend[pos] =  1;
           if (Buffer3[pos] > Buffer4[pos]) trend[pos] = -1;  
          
      } 
    
      //
      // 
      //
      //
      //
          
      if (alertsOn)
      {
          if (alertsOnCurrent)
               int whichBar = 0;
          else     whichBar = 1;

          //
          //
          //
          //
          //
         
          if (trend[whichBar] != trend[whichBar+1])
          if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Heiken Ashi ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Heiken Ashi "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
} 
    